Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Mockup/MockupDAL.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Mockup/MockupDAL.cs	(revision 9166)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Mockup/MockupDAL.cs	(revision 9166)
@@ -0,0 +1,256 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Services.Optimization.ControllerService.Interfaces;
+using Microsoft.WindowsAzure;
+using Microsoft.WindowsAzure.StorageClient;
+
+namespace HeuristicLab.Services.Optimization.ControllerService.Mockup {
+  public static class AzureConstants {
+    public static readonly string SCENARIO_TABLE = "Scenario";
+    public static readonly string SCENARIO_BLOB_CONTAINER = "scenario";
+    public static readonly string CLOUD_SETTINGS_KEY = "Cloudia.WindowsAzure.Storage";
+  }
+
+  public class ScenarioDao : IScenarioDao {
+    private static List<ScenarioEntity> scenarios;
+
+    static ScenarioDao() {
+      // TODO: Add tsp scenario to list
+      scenarios = new List<ScenarioEntity>() {
+        new ScenarioEntity("Benchmark Algorithm", "bmx", "bmm"),
+        new ScenarioEntity("Traveling Salesman Problem", "scenario1", "mapper1")
+      };      
+    }
+
+
+    public bool Add(ScenarioEntity entity) {
+      var dbEntity = scenarios.Find(e => e.Scenario == entity.Scenario);
+
+      if (dbEntity != null)
+        return false;
+
+      scenarios.Add(entity);
+      return true;
+    }
+
+    public bool DeleteByName(string scenarioName) {
+      return scenarios.RemoveAll(e => e.RowKey == scenarioName) == 1;
+    }
+
+    public ScenarioEntity FindByName(string scenarioName) {
+      return scenarios.Find(e => e.RowKey == scenarioName);      
+    }
+
+
+    public IEnumerable<ScenarioEntity> GetAllEntities() {
+      return new List<ScenarioEntity>(scenarios);
+    }
+  }
+
+  public class BlobDao : IBlobDao {
+    private static List<StringEntry> entries;
+
+    static BlobDao() {
+      entries = new List<StringEntry>() {
+        new StringEntry() {
+          Key="bmm",
+          Text=@"
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Data;
+using HeuristicLab.Services.Optimization.ControllerService.Model;
+using HeuristicLab.Optimization;
+using HeuristicLab.Services.Optimization.ControllerService;
+using HeuristicLab.Algorithms.Benchmarks;
+using HeuristicLab.Parameters;
+using HeuristicLab.PluginInfrastructure;
+
+
+namespace HeuristicLab.Mappers {
+  public class BenchmarkScenarioMapper : IScenarioMapper {
+    public void MapScenario(OptimizationScenario scenario, out IAlgorithm algorithm) {
+      var alg = scenario.FirstAlgorithm;
+      var bm = new BenchmarkAlgorithm();
+      var bmFullName = HLMapper.GetStringValue(alg.Parameters.FindByName(""Benchmark""));
+      bm.BenchmarkParameter.Value = bm.Benchmark = bm.BenchmarkParameter.ValidValues.First(b => b.GetType().FullName == bmFullName);      
+      ((ValueParameter<IntValue>)bm.Parameters[""ChunkSize""]).Value = HLMapper.ConvertToIntValue(alg.Parameters.FindByName(""ChunkSize""));
+      ((ValueParameter<DoubleValue>)bm.Parameters[""TimeLimit""]).Value = HLMapper.ConvertToDoubleValue(alg.Parameters.FindByName(""TimeLimit""));
+
+      algorithm = bm;
+    }
+  }
+}
+"
+        },
+        new StringEntry() {
+           Key="bmx",
+           Text=@"<?xml version='1.0'?>
+<scenario xmlns=""urn:scenario-schema"">
+  <name>Benchmark Algorithm</name>
+  <algorithm mapper=""HeuristicLab.Mappers.BenchmarkScenarioMapper"">
+    <parameters>
+		<param type=""Type"" name=""Benchmark"">
+		  <choice name=""HeuristicLab.Algorithms.Benchmarks.Dhrystone"" selected=""true"" />
+		  <choice name=""HeuristicLab.Algorithms.Benchmarks.Linpack"" />
+		  <choice name=""HeuristicLab.Algorithms.Benchmarks.Whetstone""/>
+		</param>    
+		<param type=""Decimal"" name=""ChunkSize"" value=""0""/>
+		<param type=""Decimal"" name=""TimeLimit"" value=""0""/> 
+	</parameters>
+  </algorithm>  
+</scenario>"
+        },
+        new StringEntry() { 
+          Key = "scenario1",
+          Text = @"<?xml version='1.0'?>
+<scenario xmlns=""urn:scenario-schema"">
+  <name>Traveling Salesman Problem</name>
+  <algorithm mapper=""HeuristicLab.Mappers.TSPScenarioMapper"">
+    <parameters>
+		<param type=""Type"" name=""CrossoverParameter"">
+		  <choice name=""OrderCrossover2""/>
+		  <choice name=""CosaCrossover"" selected=""true""/>
+		</param>    
+		<param type=""Integer"" name=""Elites"" value=""1""/>
+		<param type=""Integer"" name=""MaximumGenerations"" value=""1000""/>
+		<param type=""Percent"" name=""MutationProbability"" value=""5""/>
+		<param type=""Type"" name=""Mutator"">
+		  <choice name=""InversionManipulator"" selected=""true""/>
+		  <choice name=""ScrambleManipulator""/>
+		</param>
+		<param type=""Integer"" name=""PopulationSize"" value=""100""/>
+		<param type=""Integer"" name=""Seed"" value=""100""/>
+		<param type=""Type"" name=""Selector"">
+		  <choice name=""ProportionalSelector"" selected=""true""/>
+		  <choice name=""BestSelector""/>
+		</param>
+		<param type=""Boolean"" name=""SetSeedRandomly"" value=""true""/>
+    </parameters>
+	<problem>
+		<parameters>
+			<param type=""Decimal"" name=""BestKnownQuality"" value=""6110.0""/>
+			<param type=""DecimalVector"" name=""BestKnownSolution"">
+			  <value v1=""0""/>
+			  <value v1=""40""/>
+			  <value v1=""38""/>
+			  <value v1=""60""/>
+			</param>
+			<param type=""DecimalMatrix"" name=""Coordinates"">
+			  <value v1=""334.5909"" v2=""161.7809""/>
+			  <value v1=""503.5909"" v2=""172.7809""/>
+			  <value v1=""400.5909"" v2=""300.7809""/>
+			  <value v1=""700.5909"" v2=""700.7809""/>
+			</param>
+			<param type=""Type"" name=""EvaluatorParameter"">
+			  <choice name=""HeuristicLab.Problems.TravelingSalesman.TSPRoundedEuclideanPathEvaluator"" />
+			  <choice name=""HeuristicLab.Problems.TravelingSalesman.TSPGeoPathEvaluator"" selected=""true""/>
+			  <choice name=""HeuristicLab.Problems.TravelingSalesman.TSPEuclideanPathEvaluator""/>
+			</param>    
+			<param type=""Boolean"" name=""UseDistanceMatrix"" value=""true""/> 
+		</parameters>
+	</problem>
+  </algorithm>
+</scenario>"
+        },
+        new StringEntry() { 
+          Key = "mapper1",
+          Text = @"using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Data;
+using HeuristicLab.Services.Optimization.ControllerService.Model;
+using HeuristicLab.Optimization;
+using HeuristicLab.Services.Optimization.ControllerService;
+using HeuristicLab.Algorithms.GeneticAlgorithm;
+using HeuristicLab.Problems.TravelingSalesman;
+namespace HeuristicLab.Mappers {
+  public class TSPScenarioMapper : IScenarioMapper {
+    public void MapScenario(OptimizationScenario scenario, out IAlgorithm algorithm) {
+      Console.WriteLine(""Mapping scenario!"");
+      var ga = new GeneticAlgorithm();
+      var problem = new TravelingSalesmanProblem();
+      ga.Problem = problem;
+      algorithm = ga;
+
+      problem.BestKnownQuality = HLMapper.ConvertToDoubleValue(scenario.FirstAlgorithm.Problem.Parameters.FindByName(""BestKnownQuality""));
+      problem.BestKnownSolution = HLMapper.ConvertToPermutation(scenario.FirstAlgorithm.Problem.Parameters.FindByName(""BestKnownSolution""));
+      problem.Coordinates = HLMapper.ConvertToDoubleMatrix(scenario.FirstAlgorithm.Problem.Parameters.FindByName(""Coordinates""));
+      var evalParam = HLMapper.GetStringValue(scenario.FirstAlgorithm.Problem.Parameters.FindByName(""EvaluatorParameter""));
+      if (evalParam == ""HeuristicLab.Problems.TravelingSalesman.TSPRoundedEuclideanPathEvaluator"") {
+        problem.EvaluatorParameter.Value = new TSPRoundedEuclideanPathEvaluator();
+      }
+      else if (evalParam == ""HeuristicLab.Problems.TravelingSalesman.TSPGeoPathEvaluator"") {
+        problem.EvaluatorParameter.Value = new TSPGeoPathEvaluator();
+      }
+      else {
+        problem.EvaluatorParameter.Value = new TSPEuclideanPathEvaluator();
+      }
+      problem.UseDistanceMatrix = HLMapper.ConvertToBoolValue(scenario.FirstAlgorithm.Problem.Parameters.FindByName(""UseDistanceMatrix""));
+      Console.WriteLine(""Mapping algorithm..."");
+      ga.Mutator = HLMapper.FindInItemSet<HeuristicLab.Optimization.IManipulator>(ga.MutatorParameter.ValidValues, scenario.FirstAlgorithm.Parameters.FindByName(""Mutator""));
+      ga.CrossoverParameter.Value = HLMapper.FindOperator<HeuristicLab.Optimization.ICrossover>(problem, scenario.FirstAlgorithm.Parameters.FindByName(""CrossoverParameter""));
+      ga.Elites = HLMapper.ConvertToIntValue(scenario.FirstAlgorithm.Parameters.FindByName(""Elites""));
+      ga.MaximumGenerations = HLMapper.ConvertToIntValue(scenario.FirstAlgorithm.Parameters.FindByName(""MaximumGenerations""));
+      ga.MutationProbability = HLMapper.ConvertToPercentValue(scenario.FirstAlgorithm.Parameters.FindByName(""MutationProbability""));
+      ga.PopulationSize = HLMapper.ConvertToIntValue(scenario.FirstAlgorithm.Parameters.FindByName(""PopulationSize""));
+      ga.Seed = HLMapper.ConvertToIntValue(scenario.FirstAlgorithm.Parameters.FindByName(""Seed""));
+      ga.Selector = HLMapper.FindInItemSet<HeuristicLab.Optimization.ISelector>(ga.SelectorParameter.ValidValues, scenario.FirstAlgorithm.Parameters.FindByName(""Selector""));
+      ga.SetSeedRandomly = HLMapper.ConvertToBoolValue(scenario.FirstAlgorithm.Parameters.FindByName(""SetSeedRandomly""));
+    }
+  }
+}"
+        }
+      };
+    }
+
+    public bool Add(StringEntry entry) {
+      entries.RemoveAll(e => e.Key == entry.Key);
+      entries.Add(entry);      
+      return true;
+    }
+
+    public bool DeleteByKey(string entryKey) {
+      return entries.RemoveAll(e => e.Key == entryKey) == 1;      
+    }
+
+    public StringEntry FindByKey(string entryKey) {
+      return entries.Find(e => e.Key == entryKey);      
+    }
+  }
+
+  public class MockupDataAccessLayer : IDataAccessLayer {
+    private IScenarioDao scenarioDao;
+    private IBlobDao blobDao;
+
+    public IScenarioDao ScenarioDao {
+      get {
+        if (scenarioDao == null) {
+          scenarioDao = new ScenarioDao();
+        }
+        return scenarioDao;
+      }
+    }
+
+    public IBlobDao BlobDao {
+      get {
+        if (blobDao == null) {
+          blobDao = new BlobDao();
+        }
+        return blobDao;
+      }
+    }
+
+    public IScenarioDao CreateScenarioDao() {
+      return new ScenarioDao();
+    }
+
+    public IBlobDao CreateBlobDao() {
+      return new BlobDao();
+    }
+  }
+}
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Mockup/MockupScenarioManager.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Mockup/MockupScenarioManager.cs	(revision 9166)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Mockup/MockupScenarioManager.cs	(revision 9166)
@@ -0,0 +1,240 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Services.Optimization.ControllerService.Interfaces;
+using HeuristicLab.Optimization;
+using HeuristicLab.Algorithms.GeneticAlgorithm;
+using HeuristicLab.Problems.TravelingSalesman;
+using HeuristicLab;
+using System.Reflection;
+using HeuristicLab.Services.Optimization.ControllerService.Model;
+using HeuristicLab.Core;
+using System.Collections;
+using HeuristicLab.Clients.Hive;
+using System.Threading;
+using HeuristicLab.Data;
+using System.IO;
+using Microsoft.WindowsAzure;
+using Microsoft.WindowsAzure.StorageClient;
+using HeuristicLab.Services.Optimization.ControllerService.Azure;
+using System.Data;
+
+namespace HeuristicLab.Services.Optimization.ControllerService {
+  public class MockupScenarioManager : IScenarioManager {
+    private static List<Model.Job> jobs;
+    private static Dictionary<string, List<Model.Run>> jobResults;
+    private static IDataAccessLayer dal = DataAccessLayerProvider.GetLayer();
+    private Dictionary<string, IScenarioMapper> mappers = new Dictionary<string, IScenarioMapper>();
+    private static object lockable = new object();
+
+    static MockupScenarioManager() {
+      jobs = new List<Model.Job>() {
+        new Model.Job() { DateCreated = DateTime.Now, Id = "1", Name="Webscheduled TSP", Resource="TESTGROUP", State=JobState.Finished },
+        new Model.Job() { DateCreated = DateTime.Now, Id = "2", Name="Webscheduled TSP 2", Resource="TESTGROUP", State=JobState.Calculating }
+      };
+      jobResults = new Dictionary<string, List<Model.Run>>();
+      jobResults["1"] = new List<Model.Run>() {
+        new Model.Run() {
+          Id = "Webscheduled TSP Run 1",
+          Name = "Webscheduled TSP Run 1",
+          Results = new List<Parameter>() {
+            new Parameter() { 
+              Value = new HeuristicLab.Services.Optimization.ControllerService.Model.DecimalValue(){
+                Name = "AbsoluteDifferenceBestKnownToBest",
+                Value = 0
+              },
+              Type = ParameterType.Decimal
+            },
+            new Parameter() { 
+              Value = new HeuristicLab.Services.Optimization.ControllerService.Model.DecimalValue(){
+                Name = "BestKnownQuality",
+                Value = 1600
+              },              
+              Type = ParameterType.Decimal
+            },
+            new Parameter() { 
+              Value = new HeuristicLab.Services.Optimization.ControllerService.Model.DecimalValue(){
+                Name = "BestQuality",
+                Value = 1600
+              },              
+              Type = ParameterType.Decimal
+            },
+            new Parameter() { 
+              Value = new HeuristicLab.Services.Optimization.ControllerService.Model.DecimalValue(){
+                Name = "CurrentAverageQuality",
+                Value = 1600
+              },              
+              Type = ParameterType.Decimal
+            },
+            new Parameter() { 
+              Value = new HeuristicLab.Services.Optimization.ControllerService.Model.DecimalValue(){
+                Name = "CurrentBestQuality",
+                Value = 1600
+              },              
+              Type = ParameterType.Decimal
+            },
+            new Parameter() { 
+              Value = new HeuristicLab.Services.Optimization.ControllerService.Model.DecimalValue(){
+                Name = "CurrentWorstQuality",
+                Value = 1600
+              },              
+              Type = ParameterType.Decimal
+            },
+            new Parameter() { 
+              Value = new HeuristicLab.Services.Optimization.ControllerService.Model.DecimalValue(){
+                Name = "Evaluated Solutions",
+                Value = 99100
+              },              
+              Type = ParameterType.Decimal
+            },
+            new Parameter() { 
+              Value = new HeuristicLab.Services.Optimization.ControllerService.Model.DecimalValue(){
+                Name = "Generations",
+                Value = 1000
+              },              
+              Type = ParameterType.Decimal
+            },
+            new Parameter() { 
+              Value = new HeuristicLab.Services.Optimization.ControllerService.Model.DecimalValue(){
+                Name = "RelativeDifferenceBestKnownToBest",
+                Value = 0
+              },              
+              Type = ParameterType.Decimal
+            },
+            new Parameter() { 
+              Value = new HeuristicLab.Services.Optimization.ControllerService.Model.DecimalMatrix {
+                Name = "Qualities",
+                RowNames = new string[] { "CurrentBestQuality", "CurrentAverageQuality", "CurrentWorstQuality", "BestQuality", "BestKnownQuality" },
+                Value = new double[][] {
+                  // Best Quality
+                  new double[]{4000, 3900, 3950, 2500, 3000, 2700, 2300, 2200, 1700, 1850, 1600},
+                  // Average
+                  new double[]{6000, 5000, 5650, 3750, 4500, 4050, 3450, 3300, 2550, 2775, 2400},
+                  // Worst Quality
+                  new double[]{8000, 7200, 7350, 5000, 6000, 5400, 4600, 4400, 3400, 3700, 3200},
+                  // Best Quality
+                  new double[]{4000, 3900, 3950, 2500, 3000, 2700, 2300, 2200, 1700, 1850, 1600},
+                  // Best Known Quality
+                  new double[]{4000, 3900, 3950, 2500, 3000, 2700, 2300, 2200, 1700, 1850, 1600},
+                }
+              },              
+              Type = ParameterType.Decimal
+            }
+          }
+        }
+      };
+    }
+
+    public MockupScenarioManager() {
+      
+    }
+
+    public void DispatchScenario(Model.User user, Model.OptimizationScenario scenario, JobExecutionDetails details) {
+      // does nothign
+    }
+
+    public IList<Model.Job> GetJobs(User user) {
+      return jobs;
+    }
+
+    public Model.Job GetJob(User user, string id) {
+      return (from j in jobs where j.Id == id select j).FirstOrDefault();
+    }
+
+
+    public void DeleteJob(User user, string id) {
+      jobs.RemoveAll(j => j.Id == id);
+    }
+
+    public IList<Model.Run> GetJobResults(User user, string id) {      
+      return jobResults[id];
+    }
+
+    private static string AssemblyDirectory {
+      get {
+        string codeBase = Assembly.GetExecutingAssembly().CodeBase;
+        UriBuilder uri = new UriBuilder(codeBase);
+        string path = Uri.UnescapeDataString(uri.Path);
+        return Path.GetDirectoryName(path);
+      }
+     }
+
+    private IScenarioMapper CompileMapper(string scenarioMapper) {
+       // http://stackoverflow.com/questions/3188882/compile-and-run-dynamic-code-without-generating-exe
+      using (var csCodeProvider = new Microsoft.CSharp.CSharpCodeProvider()) {
+        var cp = new System.CodeDom.Compiler.CompilerParameters() {
+          GenerateInMemory = true
+        };
+
+        var referencedPaths = Directory.GetFiles(AssemblyDirectory, "*.dll");
+        foreach (var loadedAssembly in referencedPaths) {
+          cp.ReferencedAssemblies.Add(loadedAssembly);
+        }
+        cp.ReferencedAssemblies.Add("System.dll");
+        cp.ReferencedAssemblies.Add("System.Core.dll");
+        cp.ReferencedAssemblies.Add("System.Data.dll");
+        cp.ReferencedAssemblies.Add("System.Xml.dll");
+        cp.ReferencedAssemblies.Add("System.Xml.Linq.dll");
+
+        var res = csCodeProvider.CompileAssemblyFromSource(
+          cp,
+          scenarioMapper
+        );
+
+        foreach (var error in res.Errors) {
+          Console.WriteLine(error);
+        }
+        
+        var firstMapper = res.CompiledAssembly.GetTypes().Where(p => typeof(IScenarioMapper).IsAssignableFrom(p)).FirstOrDefault();        
+        return Activator.CreateInstance(firstMapper) as IScenarioMapper;
+      }
+    }
+
+    public bool AddScenario(User user, string scenarioName, string scenarioXml, string scenarioMapper) {     
+      // create scenario mapper
+      var mapper = CompileMapper(scenarioMapper);
+      if (mapper == null)
+        return false;
+      
+      // insert into table & blob store
+      var scenDao = dal.CreateScenarioDao();
+      var blobDao = dal.CreateBlobDao();
+      
+      Guid scenarioXmlGuid = Guid.NewGuid();
+      Guid scenarioMapperGuid = Guid.NewGuid();
+      string scenarioXmlId = scenarioName + "_" + scenarioXmlGuid.ToString();
+      string scenarioMapperId = scenarioName + "_" + scenarioMapperGuid.ToString();
+      if (!blobDao.Add(new StringEntry() { Key = scenarioXmlId, Text = scenarioXml }))
+        return false;
+      if (!blobDao.Add(new StringEntry() { Key = scenarioMapperId, Text = scenarioMapper }))
+        return false;
+      if (!scenDao.Add(new ScenarioEntity(scenarioName, scenarioXmlId, scenarioMapperId)))
+        return false;
+
+      // everything stored in the DB -> add mapper to dictionary
+      if (!mappers.ContainsKey(scenarioName)) {
+        lock (lockable) {
+          if (!mappers.ContainsKey(scenarioName))
+            mappers[scenarioName] = mapper;
+        }
+      }
+      return true;
+    }
+
+    public bool DeleteScenario(User user, string scenarioName) {
+      // delete from table & blob store
+      var scenarioDao = dal.CreateScenarioDao();
+      var blobDao = dal.CreateBlobDao();
+
+      var entity = scenarioDao.FindByName(scenarioName);
+      if (entity == null)
+        return false;
+
+      blobDao.DeleteByKey(entity.Mapper);
+      blobDao.DeleteByKey(entity.Scenario);
+      scenarioDao.DeleteByName(scenarioName);            
+      return true;
+    }
+  }
+}
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/PlaceholderControllerService.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/PlaceholderControllerService.cs	(revision 9165)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/PlaceholderControllerService.cs	(revision 9166)
@@ -51,4 +51,5 @@
       this.scenarios = new List<Model.OptimizationScenario>() { tsp };*/      
       //hiveManager.DispatchScenario(tsp);
+      //hiveManager = new MockupScenarioManager();
       hiveManager = new HiveScenarioManager();
       scenarios = parser.Scenarios;
@@ -63,11 +64,11 @@
     public Model.OptimizationScenario GetOptimizationScenarioByName(string name) {
       var scen = (from e in scenarios
-                  where e.Name == name
+                  where e.Id == name
                   select e).FirstOrDefault();      
       return scen;
     }
 
-    public void ScheduleOptimizationScenario(Model.User user, Model.OptimizationScenario scenario) {
-      hiveManager.DispatchScenario(user, scenario);
+    public void ScheduleOptimizationScenario(Model.User user, Model.OptimizationScenario scenario, JobExecutionDetails details) {
+      hiveManager.DispatchScenario(user, scenario, details);
     }
 
@@ -97,5 +98,5 @@
         return false;
       }      
-      var added = hiveManager.AddScenario(user, scenario.Name, scenarioXml, scenarioMapper);
+      var added = hiveManager.AddScenario(user, scenario.Id, scenarioXml, scenarioMapper);
       if (added) 
         scenarios.Add(scenario);
@@ -114,5 +115,5 @@
     public IEnumerable<string> GetOptimizationScenarioNames() {
       return (from e in scenarios
-              select e.Name).AsEnumerable();      
+              select e.Id).AsEnumerable();      
     }
   }
Index: /branches/OaaS/HeuristicLab.Services.Optimization.ControllerService.Tests/HeuristicLab.Services.Optimization.ControllerService.Tests.csproj
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.ControllerService.Tests/HeuristicLab.Services.Optimization.ControllerService.Tests.csproj	(revision 9165)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.ControllerService.Tests/HeuristicLab.Services.Optimization.ControllerService.Tests.csproj	(revision 9166)
@@ -40,4 +40,8 @@
       <HintPath>..\bin\ALGLIB-3.5.0.dll</HintPath>
     </Reference>
+    <Reference Include="HeuristicLab.Algorithms.Benchmarks-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\bin\HeuristicLab.Algorithms.Benchmarks-3.3.dll</HintPath>
+    </Reference>
     <Reference Include="HeuristicLab.Algorithms.GeneticAlgorithm-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
       <SpecificVersion>False</SpecificVersion>
Index: /branches/OaaS/HeuristicLab.Services.Optimization.ControllerService.Tests/Program.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.ControllerService.Tests/Program.cs	(revision 9165)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.ControllerService.Tests/Program.cs	(revision 9166)
@@ -12,4 +12,5 @@
 using HeuristicLab.Persistence.Core;
 using HeuristicLab.Core;
+using HeuristicLab.Optimization;
 
 namespace HeuristicLab.Services.Optimization.ControllerService.Tests {
@@ -17,6 +18,6 @@
     static void Main(string[] args) {
       Console.WriteLine(AppDomain.CurrentDomain.BaseDirectory);    
-      //TestScenarioParser();
-      TestCodeDOM();
+      TestScenarioParser();
+      //TestCodeDOM();
       //TestPython();
       //TestOtis();
@@ -65,5 +66,5 @@
         cp.ReferencedAssemblies.Add("System.dll");
 
-        tsp.BestKnownQuality = HLMapper.ConvertToDoubleValue(scen.InputParameters.FindByName("BestKnownQuality"));
+        tsp.BestKnownQuality = HLMapper.ConvertToDoubleValue(scen.FirstAlgorithm.Problem.Parameters.FindByName("BestKnownQuality"));
         
         var res = csCodeProvider.CompileAssemblyFromSource(
@@ -120,5 +121,5 @@
         var type = res.CompiledAssembly.GetType("TSPScenarioMapper");
         var mapper = Activator.CreateInstance(type) as IScenarioMapper;
-        mapper.MapScenario(scen, algo);
+        //mapper.MapScenario(scen, algo);
       }      
     }
@@ -217,8 +218,44 @@
     static void TestScenarioParser() {
       ScenarioParser parser = new ScenarioParser();
-      var scen = parser.GetByName("Traveling Salesman Problem");
-      TravelingSalesmanProblem tsp = new TravelingSalesmanProblem();
-      // proceed with mapping between scen and tsp
+      //var scen = parser.GetByName("Traveling Salesman Problem");
+      var scen = parser.GetByName("Benchmark Algorithm");
+
+      var mapper = HiveScenarioManager.CompileMapper(
+@"
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Data;
+using HeuristicLab.Services.Optimization.ControllerService.Model;
+using HeuristicLab.Optimization;
+using HeuristicLab.Services.Optimization.ControllerService;
+using HeuristicLab.Algorithms.Benchmarks;
+using HeuristicLab.Parameters;
+using HeuristicLab.PluginInfrastructure;
+
+
+namespace HeuristicLab.Mappers {
+  public class BenchmarkScenarioMapper : IScenarioMapper {
+    public void MapScenario(OptimizationScenario scenario, out IAlgorithm algorithm) {
+      var alg = scenario.FirstAlgorithm;
+      var bm = new BenchmarkAlgorithm();
+      bm.Benchmark = (IBenchmark) Activator.CreateInstance((from t in ApplicationManager.Manager.GetTypes(typeof(IBenchmark))
+                        where t.Name == HLMapper.GetStringValue(alg.Parameters.FindByName(""Benchmark""))
+                       select t).FirstOrDefault());
+      ((ValueParameter<IntValue>)bm.Parameters[""ChunkSize""]).Value = HLMapper.ConvertToIntValue(alg.Parameters.FindByName(""ChunkSize""));
+      ((ValueParameter<DoubleValue>)bm.Parameters[""TimeLimit""]).Value = HLMapper.ConvertToDoubleValue(alg.Parameters.FindByName(""TimeLimit""));
+
+      algorithm = bm;
     }
   }
 }
+
+");
+      IAlgorithm algo;
+      //mapper = new BenchmarkScenarioMapper();
+      mapper.MapScenario(scen, out algo);
+      // proceed with mapping between scen and tsp
+    }
+  }
+}
Index: /branches/OaaS/HeuristicLab.Services.Optimization.ControllerService.Tests/mappings/scenario.xsd
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.ControllerService.Tests/mappings/scenario.xsd	(revision 9165)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.ControllerService.Tests/mappings/scenario.xsd	(revision 9166)
@@ -8,16 +8,28 @@
  <xsd:complexType name="scenarioType">
   <xsd:sequence maxOccurs="1">   
-   <xsd:element name="name" type="xsd:string"/>
-   <xsd:element name="problemParameters" type="paramsType"/>
-   <xsd:element name="algorithmParameters" type="paramsType"/>
-  </xsd:sequence>
-  <xsd:attribute name="problemType" use="required"/>
-  <xsd:attribute name="algorithmType" use="required"/>
-  <xsd:attribute name="mapper" use="required"/>
+   <xsd:element name="name" minOccurs="1" type="xsd:string"/>   
+   <xsd:element name="algorithm" minOccurs="1" maxOccurs="unbounded" type="algorithmType"/>   
+  </xsd:sequence>  
  </xsd:complexType>
+
+<xsd:complexType name="algorithmType">
+  <xsd:sequence maxOccurs="1">
+	<xsd:element name="parameters" type="paramsType"/>
+	<xsd:element name="problem" minOccurs="0" type="problemType"/>	
+	<xsd:element name="algorithm" minOccurs="0" maxOccurs="unbounded" type="algorithmType"/>		
+  </xsd:sequence>  
+  <xsd:attribute name="mapper" use="required"/>		
+</xsd:complexType>
+
+<xsd:complexType name="problemType">
+  <xsd:sequence maxOccurs="1">
+	<xsd:element name="parameters" type="paramsType"/>	
+  </xsd:sequence>  
+  <xsd:attribute name="class"/>	
+</xsd:complexType>
 
  <xsd:complexType name="paramsType">
   <xsd:sequence>
-   <xsd:element name="param" type="parameterType" minOccurs="1" maxOccurs="unbounded"/>      
+   <xsd:element name="param" type="parameterType" minOccurs="0" maxOccurs="unbounded"/>      
   </xsd:sequence>  
  </xsd:complexType>
